/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import omo2.list.LinkedList;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author strnapa1
 */
public class LinkedListTest {
    LinkedList<Integer> l;
    public LinkedListTest() {
    }
    
    @BeforeClass
    public static void setUpClass() {
    }
    
    @AfterClass
    public static void tearDownClass() {
    }
    
    @Before
    public void setUp() {
        this.l = new LinkedList();
    }
    
    @After
    public void tearDown() {
    }

    @Test
    public void createList() {
        LinkedList<Integer> l = new LinkedList<>();
        assertTrue(l != null);
    }
    
    @Test
    public void emptyList() {
        assertTrue(this.l.isEmpty());
        assertTrue(this.l.size()==0);
    }
    
    @Test
    public void addValue() {
        this.l.addValue(10);
        assertTrue(this.l.size()==1);
        assertTrue(this.l.getData(0)==10);
        assertTrue(this.l.contains(10));
    }
    
    @Test
    public void testIterator() {
        this.l.addValue(10);
        this.l.addValue(20);
        this.l.addValue(30);
        Integer[] arr = new Integer[3];
        int cnt = 0;
        for(Integer i : this.l) {
            arr[cnt] = i;
            cnt++;
        }
        assertArrayEquals(arr, new Integer[]{10, 20, 30});
    }

    
    @Test
    public void insertValue() {
        this.l.addValue(10);
        this.l.addValue(20);
        this.l.insert(1, 15);
        assertTrue(this.l.size()==3);
        assertTrue(this.l.getData(1)==15);
        assertTrue(this.l.contains(15));
    }
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //
    // @Test
    // public void hello() {}
}
