package omo3;

/*
 *   Node pro jednosmerny spojovy seznam
 */

public class Node<E> {

    private E data;
    private Node next;

    // konstructor 1
    public Node(E data) {
        this.data = data;
        this.next = null;
    }

    // konstructor 2
    public Node(E data, Node node) {
        this.data = data;
        next = node;
    }


    // vrátí uložená data v Node
    public E getData() {
        return data;
    }

    // nastaví data do Node
    public void setData(E data) {
        this.data = data;
    }

    // vrati ukazatel na dalsi prvek
    public Node getNext() {
        return next;
    }
    // nastavi ukazatel na dalsi prvek
    public void setNext(Node next) {
        this.next = next;
    }

}